﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	Private Input_Dialog As CustomLayoutDialog
	Private fledtInputbox As FloatLabeledEditText
	Private lblInputBox As Label
	Private sUtils As StringUtils
	Private mbHidePassword As Boolean
	Private BC As ByteConverter
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

Public Sub ShowError(strTitle As String, strError As String, bWait As Boolean) As ResumableSub
	
	Dim lPos As Int
	
	If strError.Length = 0 Then
		If LastException.IsInitialized = False Then
			Msgbox2Async("There was no error", strTitle, "OK", "", "", Starter.bmpIcon32, False)
			Return 0
		Else
			strError = LastException.Message
			lPos = strError.IndexOf("###")
			If lPos > -1 And lPos < strError.Length - 1 Then
				strError = strError.SubString2(0, lPos)
			End If
		End If
	End If
	
	Msgbox2Async(strError, strTitle, "OK", "", "", Starter.bmpIcon32, False)
	
	If bWait Then
		Wait For Msgbox_Result(iResult As Int)
		Return iResult
	End If
	
End Sub

Public Sub InputBox2(strPrompt As String, _
			  strTitle As String, _
			  strHint As String, _
			  strDefault As String, _
			  iTitleFontSize As Int, _
			  iTitleFontColour As Int, _
		   	  iPromptColour As Int, _
			  iHintColour As Int, _
			  iInputColour As Int, _
		   	  csPrompt As CSBuilder, _
		   	  bmpIcon As Bitmap, _
		   	  bCancelable As Boolean, _
			  iPromptHeight As Int, _
			  bHidePassword As Boolean) As ResumableSub
			  
	Dim csPrompt As CSBuilder
	Dim csTitle As CSBuilder
	Dim oJava As JavaObject
	
	mbHidePassword = bHidePassword
	
	If iTitleFontColour = 0 Then
		iTitleFontColour = Colors.RGB(0, 0, 0)
	End If
	
	If iPromptColour = 0 Then
		iPromptColour = Colors.RGB(0, 0, 0)
	End If
	
	If iHintColour = 0 Then
		iHintColour = Colors.RGB(0, 0, 0)
	End If
	
	If iInputColour = 0 Then
		iInputColour = Colors.RGB(0, 0, 0)
	End If
	
	If csPrompt.IsInitialized = False Then
		csPrompt.Initialize.Size(16).Color(iPromptColour).Append(strPrompt).PopAll
	End If
	
	csTitle.Initialize.Typeface(Typeface.DEFAULT).Size(iTitleFontSize).Color(iTitleFontColour).Append(strTitle).PopAll
	
	'note here that the OK and Cancel have been swapped!!
	'----------------------------------------------------
	oJava = Input_Dialog.ShowAsync(csTitle, "Cancel", "OK", "", Starter.bmpIcon32, bCancelable)
	oJava.RunMethod("setTitle", Array(csTitle))
	
	Wait For (oJava) Dialog_Ready(pnl As Panel) '>>>>>> code stops here, but no error!
	pnl.LoadLayout("Input_Dialog")
	
	fledtInputbox.Hint = strHint
	fledtInputbox.EditText.TextColor = iInputColour
	fledtInputbox.EditText.HintColor = iHintColour
	
	'as we have the hint, no prompt label may be needed
	If strPrompt.Length > 0 Then
		If iPromptHeight = -1 Then
			lblInputBox.Height = sUtils.MeasureMultilineTextHeight(lblInputBox, csPrompt) + 20dip
		Else
			'not sure we need this option, MeasureMultilineTextHeight seems to work well
			lblInputBox.Height = iPromptHeight
		End If
		Input_Dialog.SetSize(96%x, lblInputBox.Height  + 200dip)
		lblInputBox.Text = csPrompt
	Else
		Input_Dialog.SetSize(96%x, 200dip)
		lblInputBox.Visible = False
	End If
	
	If strDefault.Length > 0 Then
		fledtInputbox.Text = strDefault
	End If
	
	Wait For (oJava) Dialog_Result(res As Int)
	
	'note here that the OK and Cancel have been swapped!!
	'----------------------------------------------------
	If res = DialogResponse.CANCEL Then
		Return fledtInputbox.text 'OK button
	Else
		Return "" 'Cancel button
	End If
	
End Sub

Sub fledtInputbox_TextChanged (Old As String, New As String)
	
	If mbHidePassword And New.Length > 0 Then
		fledtInputbox.Text = MakeString(88, New.Length)
	End If
	
	If fledtInputbox.IsInitialized Then
		Input_Dialog.GetButton(DialogResponse.POSITIVE).Enabled = fledtInputbox.Text.Length > 0
	End If

End Sub

Sub MakeString(btByte As Byte, lNum As Long) As String
	
	Dim i As Long
	Dim arrBytes(lNum) As Byte
	
	For i = 0 To lNum - 1
		arrBytes(i) = btByte
	Next
	
	Return BC.StringFromBytes(arrBytes, "ASCII")

End Sub
